<?php defined('SYSPATH') or die('No direct script access.');

/**
 * Class Model_Plan
 *
 * @property-read   $ID             int
 * @property        $ExternalID     string
 * @property        $FacultyID      int
 * @property        $SemesterID     int
 * @property        $GradeID        int
 */
class Model_Plan extends Model_Container
{
    protected function getRawData($id) {
        $sql = 'CALL `Plan_GetInfo`(:id)';
        $info = DB::query(Database::SELECT, $sql)
            ->param(':id', $id)->execute();

        if ($info->count() == 0)
            throw new InvalidArgumentException('Study plan not found');

        return $info->offsetGet(0);
    }

    public static function make() {
        return new Model_Helper_PlanBuilder();
    }

    protected function create() {
//        $sql = 'SELECT `CreateStudentGroupSearch`(LastName, FirstName, SecondName, GradeID, GroupNum, FacultyID, ActivationCode, SemesterID) AS `ID`';
//
//        $this->data[self::$ID_FIELD] = DB::query(Database::SELECT, $sql)
//            ->parameters($this->data)
//            ->execute()->get('ID');
//
//        if ($this->ID <= 0)
//            throw new InvalidArgumentException(Error::INVALID_PARAMETERS);
    }

    /**
     * @param string $extid
     * @return int
     */
    public static function withExternalID($extid, $year=null, $facultyID=null) {
        $sql = 'SELECT `Plan_GetIDFromExternalID`(:extid) AS `ID`';
        $id = DB::query(Database::SELECT, $sql)
            ->param(':extid', $extid)
            ->execute()->get('ID');

        if ($id == -1) {
            if ($year === null)
                $year = Model_Semesters::load(Model_System::$SemesterID)->year;
            if ($facultyID === null)
                throw new InvalidArgumentException('Cann\'t create plan without faculty.');
            $sql = 'SELECT `Plan_Create`(:extid, :year, :faculty) AS `ID`';
            $id = DB::query(Database::SELECT, $sql)
                ->param(':extid', $extid)
                ->param(':year', $year)
                ->param(':faculty', $facultyID)
                ->execute()->get('ID');
        }

        return $id;
    }

    /** @return Model_Discipline[] */
    public function getDisciplines($semesterID = null) {
        throw new BadMethodCallException('Method is not implemented yet!');
    }

    public function getTeachers($loadAll = false, $semesterID = null) {
        throw new BadMethodCallException('Method is not implemented yet!');
    }

    // todo implementation
    public function update() {
        throw new BadMethodCallException('Method is not implemented yet!');
    }
}
